import { Component, OnInit } from "@angular/core";

import { Item } from "./item";
import { ItemService } from "./item.service";
var http = require("http");

@Component({
    selector: "ns-items",
    moduleId: module.id,
    templateUrl: "./items.component.html",
})
export class ItemsComponent implements OnInit {
    items: Item[];
    DefaultImage = "res://user_circle_o_384_0_e0e0e0"
    // This pattern makes use of Angular’s dependency injection implementation to inject an instance of the ItemService service into this class. 
    // Angular knows about this service because it is included in your app’s main NgModule, defined in app.module.ts.
    constructor(private itemService: ItemService) { }

    ngOnInit(): void {
        this.items = this.itemService.getItems();
        this.getImages();
    }

    async getImages()
    {
        for(const item of this.items)
        {
            await this.getImage()
            .then((args)=>{
                item.image = args;
            }, (err)=>{
                console.log("error");
            });
            await this.delay(500);
        }
    }

    delay(ms: number) {
        return new Promise<void>(function(resolve) {
            setTimeout(resolve, ms);
        });
    }

    getImage() 
    {
        const address: string = "https://dummyimage.com/16:9x1080/";
        // const authorization: string; It's not necessary right now
        const request = {
            url: address,
            method: "GET",
            //headers: {
            //    Authorization: authorization
            //}
        };
        return http.getImage(request);
    }
}